From c43627aee6c9caf021e6a931687aea631579f37b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 28 2020 08:50:25 +0000
Subject: [PATCH 22/2232] Always write cxxbridge.h into a predictable place from build script


---

diff --git a/demo-cxx/demo.h b/demo-cxx/demo.h
index 51dd81b..417edfb 100644
--- a/demo-cxx/demo.h
+++ b/demo-cxx/demo.h
@@ -1,5 +1,5 @@
 #pragma once
-#include "../include/cxxbridge.h"
+#include "cxxbridge/cxxbridge.h"
 #include <memory>
 #include <string>
 
diff --git a/src/lib.rs b/src/lib.rs
index 3267b3f..6f40124 100644
--- a/src/lib.rs
+++ b/src/lib.rs
@@ -463,5 +463,10 @@ fn try_generate_bridge(rust_source_file: &Path) -> Result<cc::Build> {
     let mut build = paths::cc_build();
     build.file(&bridge_path);
 
+    let ref cxxbridge_h = paths::include_dir()?.join("cxxbridge/cxxbridge.h");
+    let _ = fs::create_dir_all(cxxbridge_h.parent().unwrap());
+    let _ = fs::remove_file(cxxbridge_h);
+    let _ = fs::write(cxxbridge_h, gen::include::HEADER);
+
     Ok(build)
 }
diff --git a/src/paths.rs b/src/paths.rs
index 16bf12a..f253939 100644
--- a/src/paths.rs
+++ b/src/paths.rs
@@ -15,11 +15,9 @@ pub(crate) fn cc_build() -> cc::Build {
 }
 
 fn try_cc_build() -> Result<cc::Build> {
-    let target_dir = target_dir()?;
-
     let mut build = cc::Build::new();
-    build.include(target_dir.join("cxxbridge"));
-    build.include(target_dir.parent().unwrap());
+    build.include(include_dir()?);
+    build.include(target_dir()?.parent().unwrap());
     Ok(build)
 }
 
@@ -31,7 +29,7 @@ pub(crate) fn symlink_header(path: &Path, original: &Path) {
 
 fn try_symlink_header(path: &Path, original: &Path) -> Result<()> {
     let suffix = relative_to_parent_of_target_dir(original)?;
-    let ref dst = target_dir()?.join("cxxbridge").join(suffix);
+    let ref dst = include_dir()?.join(suffix);
 
     fs::create_dir_all(dst.parent().unwrap())?;
     let _ = fs::remove_file(dst);
@@ -67,6 +65,11 @@ pub(crate) fn out_with_extension(path: &Path, ext: &str) -> Result<PathBuf> {
     Ok(out_dir.join(rel).with_file_name(file_name))
 }
 
+pub(crate) fn include_dir() -> Result<PathBuf> {
+    let target_dir = target_dir()?;
+    Ok(target_dir.join("cxxbridge"))
+}
+
 fn target_dir() -> Result<PathBuf> {
     let mut dir = out_dir()?.canonicalize()?;
     loop {

